/*
 * This file is generated by jOOQ.
 */
package nu.studer.sample.tables.records;


import java.util.UUID;

import javax.annotation.processing.Generated;

import nu.studer.sample.tables.PurposeCategories;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record2;
import org.jooq.Row2;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "https://www.jooq.org",
        "jOOQ version:3.15.1"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class PurposeCategoriesRecord extends UpdatableRecordImpl<PurposeCategoriesRecord> implements Record2<UUID, String> {

    private static final long serialVersionUID = 1L;

    /**
     * Setter for <code>selfbooster.purpose_categories.uuid</code>.
     */
    public PurposeCategoriesRecord setUuid(UUID value) {
        set(0, value);
        return this;
    }

    /**
     * Getter for <code>selfbooster.purpose_categories.uuid</code>.
     */
    public UUID getUuid() {
        return (UUID) get(0);
    }

    /**
     * Setter for <code>selfbooster.purpose_categories.category_name</code>.
     */
    public PurposeCategoriesRecord setCategoryName(String value) {
        set(1, value);
        return this;
    }

    /**
     * Getter for <code>selfbooster.purpose_categories.category_name</code>.
     */
    public String getCategoryName() {
        return (String) get(1);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    @Override
    public Record1<UUID> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record2 type implementation
    // -------------------------------------------------------------------------

    @Override
    public Row2<UUID, String> fieldsRow() {
        return (Row2) super.fieldsRow();
    }

    @Override
    public Row2<UUID, String> valuesRow() {
        return (Row2) super.valuesRow();
    }

    @Override
    public Field<UUID> field1() {
        return PurposeCategories.PURPOSE_CATEGORIES.UUID;
    }

    @Override
    public Field<String> field2() {
        return PurposeCategories.PURPOSE_CATEGORIES.CATEGORY_NAME;
    }

    @Override
    public UUID component1() {
        return getUuid();
    }

    @Override
    public String component2() {
        return getCategoryName();
    }

    @Override
    public UUID value1() {
        return getUuid();
    }

    @Override
    public String value2() {
        return getCategoryName();
    }

    @Override
    public PurposeCategoriesRecord value1(UUID value) {
        setUuid(value);
        return this;
    }

    @Override
    public PurposeCategoriesRecord value2(String value) {
        setCategoryName(value);
        return this;
    }

    @Override
    public PurposeCategoriesRecord values(UUID value1, String value2) {
        value1(value1);
        value2(value2);
        return this;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached PurposeCategoriesRecord
     */
    public PurposeCategoriesRecord() {
        super(PurposeCategories.PURPOSE_CATEGORIES);
    }

    /**
     * Create a detached, initialised PurposeCategoriesRecord
     */
    public PurposeCategoriesRecord(UUID uuid, String categoryName) {
        super(PurposeCategories.PURPOSE_CATEGORIES);

        setUuid(uuid);
        setCategoryName(categoryName);
    }

    /**
     * Create a detached, initialised PurposeCategoriesRecord
     */
    public PurposeCategoriesRecord(nu.studer.sample.tables.pojos.PurposeCategories value) {
        super(PurposeCategories.PURPOSE_CATEGORIES);

        if (value != null) {
            setUuid(value.getUuid());
            setCategoryName(value.getCategoryName());
        }
    }
}
